Loading...
Searching...
No Matches
casacore::MPosition Class Reference
measures package (libcasa_measures) » Measures_module

More...

`#include <MPosition.h>`

## Public Types

enum | Types { ITRF , WGS84 , N_Types , DEFAULT }
| Types of known MPositions Warning: The order defines the order in the translation matrix FromTo in the getConvert routine; Do not change the order without changing the array; Additions should be made before N_types, and an additional row and column should be coded in FromTo, and in showType(); . More...
typedef MVPosition | MVType
| Measure value container for this class (i.e.
typedef MCPosition | MCType
| Measure conversion routines for this class (i.e.
typedef MeasRef< MPosition > | Ref
| Measure reference (i.e.
typedef MeasConvert< MPosition > | Convert
| Measure Convert (i.e.
typedef ScalarMeasColumn< MPosition > | ScalarColumn
| Measure table Columns (e.g., MPosition::ScalarColumn).
typedef ArrayMeasColumn< MPosition > | ArrayColumn
Public Types inherited from casacore::Measure
enum | Types { N_Types , DEFAULT }
| Each derived class should have a Types enumeration, specifying the recognised frame types. More...
typedef void * | Convert
| Each Measure should have typedefs of the form:

## Public Member Functions

| MPosition ()
| Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference; Default constructor; generates the ITRF centre
| MPosition (const MVPosition &dt)
| Create from data and reference.
| MPosition (const MVPosition &dt, const MPosition::Ref &rf)
| MPosition (const MVPosition &dt, MPosition::Types rf)
| MPosition (const Quantity &dt, const Quantity &dt1, const Quantity &dt2)
| MPosition (const Quantity &dt, const Quantity &dt1, const Quantity &dt2, const MPosition::Ref &rf)
| MPosition (const Quantity &dt, const Quantity &dt1, const Quantity &dt2, MPosition::Types rf)
| MPosition (const Quantity &dt0, const Quantum< Vector< Double > > &dt)
| MPosition (const Quantity &dt0, const Quantum< Vector< Double > > &dt, const MPosition::Ref &rf)
| MPosition (const Quantity &dt0, const Quantum< Vector< Double > > &dt, MPosition::Types rf)
| MPosition (const Measure *dt)
| MPosition (const MeasValue *dt)
| MPosition (const MPosition &)
MPosition & | operator= (const MPosition &)
virtual | ~MPosition ()
virtual const String & | tellMe () const
| Tell me your type.
Bool | giveMe (MPosition::Ref &mr, const String &in)
virtual Bool | setOffset (const Measure &in)
| Set the offset in the reference (False if non-matching Measure).
virtual Bool | setRefString (const String &in)
| Set the reference type to the specified String.
virtual const String & | getDefaultType () const
| Get the default reference type.
virtual const String * | allTypes (Int &nall, Int &nextra, const uInt *&typ) const
| Get a list of all known reference codes.
virtual void | checkTypes () const
| Check if all internal tables of types (both enum and String) are complete and correct.
virtual String | getRefString () const
| Get the reference type (for records, including codes like R_).
Quantum< Vector< Double > > | get (const Unit &inunit) const
| Get Measure data.
Quantum< Vector< Double > > | getAngle () const
Quantum< Vector< Double > > | getAngle (const Unit &inunit) const
virtual Measure * | clone () const
| Make copy.
Public Member Functions inherited from casacore::MeasBase< MVPosition, MeasRef< MPosition > >
| MeasBase ()
| Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference; For reasons of compiler limitations the formal arguments had to be specified as uInt rather than the Measure enums that should be used as actual arguments; Default constructor
MeasBase< MVPosition, MeasRef< MPosition > > & | operator= (const MeasBase< MVPosition, MeasRef< MPosition > > &other)
| Copy assignment.
virtual | ~MeasBase ()
virtual Bool | areYou (const String &tp) const
| Check the type of derived entity.
virtual void | assured (const String &tp) const
| Assert that we are the correct type.
void | set (const MVPosition &dt)
| Refill the specified entities.
virtual Bool | putValue (const Vector< Quantum< Double > > &in)
MeasRef< MPosition > | getRef () const
| Get reference.
const MVPosition & | getValue () const
| Get Measure data.
const Unit & | getUnit () const
| Get Unit.
virtual MRBase * | getRefPtr () const
| Get reference pointer.
virtual const MeasValue * | getData () const
| Get pointer to data.
virtual void | print (std::ostream &os) const
| Print a Measure.
Public Member Functions inherited from casacore::Measure
virtual | ~Measure ()
| Destructor.
virtual void | set (const MeasValue &dt)=0
| Each Measure should have the following set functions (with appropiate MVs and Ref):
virtual Bool | isModel () const
| Tell me if you are a pure model (e.g.
void | dummy_giveMe () const
| Each derived class should have a string-to-code translation routine for the reference type.
void | dummy_getRef () const
| Each class should have a function to return its reference:
void | dummy_getValue () const
| Each derived class should be able to get its internal value and have:

## Static Public Member Functions

static const String & | showMe ()
static void | assure (const Measure &in)
static MPosition::Types | castType (uInt tp)
| Translate reference code.
static const String & | showType (MPosition::Types tp)
static const String & | showType (uInt tp)
static Bool | getType (MPosition::Types &tp, const String &in)
| Translate string to reference code.
static MPosition::Types | getType (const String &in)
| this one throws an exception for an unrecognized String
static const String * | allMyTypes (Int &nall, Int &nextra, const uInt *&typ)
static void | checkMyTypes ()
Static Public Member Functions inherited from casacore::Measure
static uInt | giveMe (const String &in, Int N_name, const String tname[])
| A general string checking routine to be used in derived measures.

## Friends

class | MeasConvert< MPosition >
| Conversion of data.

## Additional Inherited Members

Protected Attributes inherited from casacore::MeasBase< MVPosition, MeasRef< MPosition > >
MVPosition | data
| The measure value (e.g.
MeasRef< MPosition > | ref
| Reference frame data.
Unit | unit
| Possible input units.

## Detailed Description

A Measure: position on Earth

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tMeasure

### Prerequisite

- Measure class

### Etymology

### Synopsis

MPosition forms derived Measure class for an instant in time.

### Example

### Motivation

### To Do

Definition at line 76 of file MPosition.h.

## Member Typedef Documentation

## ArrayColumn

typedef ArrayMeasColumn<MPosition> casacore::MPosition::ArrayColumn

Definition at line 108 of file MPosition.h.

## Convert

typedef MeasConvert<MPosition> casacore::MPosition::Convert

Measure Convert (i.e.

MPosition::Convert)

Definition at line 105 of file MPosition.h.

## MCType

typedef MCPosition casacore::MPosition::MCType

Measure conversion routines for this class (i.e.

MPosition::MCType)

Definition at line 101 of file MPosition.h.

## MVType

typedef MVPosition casacore::MPosition::MVType

Measure value container for this class (i.e.

MPosition::MVType)

Definition at line 99 of file MPosition.h.

## Ref

typedef MeasRef<MPosition> casacore::MPosition::Ref

Measure reference (i.e.

MPosition::Ref)

Definition at line 103 of file MPosition.h.

## ScalarColumn

typedef ScalarMeasColumn<MPosition> casacore::MPosition::ScalarColumn

Measure table Columns (e.g., MPosition::ScalarColumn).

Definition at line 107 of file MPosition.h.

## Member Enumeration Documentation

## Types

enum casacore::MPosition::Types

Types of known MPositions
Warning: The order defines the order in the translation matrix FromTo in the getConvert routine; Do not change the order without changing the array; Additions should be made before N_types, and an additional row and column should be coded in FromTo, and in showType();
.

Enumerator
ITRF |
WGS84 |
N_Types |
DEFAULT |

Definition at line 91 of file MPosition.h.

## Constructor & Destructor Documentation

## MPosition() [1/13]

casacore::MPosition::MPosition | ( |  | ) |

Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference;
Default constructor; generates the ITRF centre

Referenced by MeasConvert< MPosition >, MPosition(), and operator=().

## MPosition() [2/13]

casacore::MPosition::MPosition | ( | const MVPosition & | dt | ) |

Create from data and reference.

## MPosition() [3/13]

casacore::MPosition::MPosition | ( | const MVPosition & | dt,
|  | const MPosition::Ref & | rf )

## MPosition() [4/13]

casacore::MPosition::MPosition | ( | const MVPosition & | dt,
|  | MPosition::Types | rf )

## MPosition() [5/13]

casacore::MPosition::MPosition | ( | const Quantity & | dt,
|  | const Quantity & | dt1,
|  | const Quantity & | dt2 )

## MPosition() [6/13]

casacore::MPosition::MPosition | ( | const Quantity & | dt,
|  | const Quantity & | dt1,
|  | const Quantity & | dt2,
|  | const MPosition::Ref & | rf )

## MPosition() [7/13]

casacore::MPosition::MPosition | ( | const Quantity & | dt,
|  | const Quantity & | dt1,
|  | const Quantity & | dt2,
|  | MPosition::Types | rf )

## MPosition() [8/13]

casacore::MPosition::MPosition | ( | const Quantity & | dt0,
|  | const Quantum< Vector< Double > > & | dt )

## MPosition() [9/13]

casacore::MPosition::MPosition | ( | const Quantity & | dt0,
|  | const Quantum< Vector< Double > > & | dt,
|  | const MPosition::Ref & | rf )

## MPosition() [10/13]

casacore::MPosition::MPosition | ( | const Quantity & | dt0,
|  | const Quantum< Vector< Double > > & | dt,
|  | MPosition::Types | rf )

## MPosition() [11/13]

casacore::MPosition::MPosition | ( | const Measure * | dt | ) |

## MPosition() [12/13]

casacore::MPosition::MPosition | ( | const MeasValue * | dt | ) |

## MPosition() [13/13]

casacore::MPosition::MPosition | ( | const MPosition & |  | ) |

References MPosition().

## ~MPosition()

virtual casacore::MPosition::~MPosition | ( |  | ) |

virtual

## Member Function Documentation

## allMyTypes()

const String * casacore::MPosition::allMyTypes | ( | Int & | nall,
|  | Int & | nextra,
|  | const uInt *& | typ )

static

## allTypes()

virtual const String * casacore::MPosition::allTypes | ( | Int & | nall,
|  | Int & | nextra,
|  | const uInt *& | typ ) const

virtual

Get a list of all known reference codes.

nall returns the number in list, nextra the number of specials (like planets) that should be at end of list). typ returns the list of corresponding types.

Reimplemented from casacore::Measure.

## assure()

void casacore::MPosition::assure | ( | const Measure & | in | ) |

static

## castType()

MPosition::Types casacore::MPosition::castType | ( | uInt | tp | ) |

static

Translate reference code.

The uInt version has a check for valid codes (i.e. it is a safe cast).

### Thrown Exceptions

- AipsError in the uInt interface if illegal code given

## checkMyTypes()

void casacore::MPosition::checkMyTypes | ( |  | ) |

static

## checkTypes()

virtual void casacore::MPosition::checkTypes | ( |  | ) | const

virtual

Check if all internal tables of types (both enum and String) are complete and correct.

This function is called automatically if and when necessary.

### Thrown Exceptions

- AipsError if a (programming) error in the types.

Implements casacore::Measure.

## clone()

virtual Measure * casacore::MPosition::clone | ( |  | ) | const

virtual

Make copy.

Implements casacore::Measure.

## get()

Quantum< Vector< Double > > casacore::MPosition::get | ( | const Unit & | inunit | ) | const

Get Measure data.

## getAngle() [1/2]

Quantum< Vector< Double > > casacore::MPosition::getAngle | ( |  | ) | const

## getAngle() [2/2]

Quantum< Vector< Double > > casacore::MPosition::getAngle | ( | const Unit & | inunit | ) | const

## getDefaultType()

virtual const String & casacore::MPosition::getDefaultType | ( |  | ) | const

virtual

Get the default reference type.

Implements casacore::Measure.

## getRefString()

virtual String casacore::MPosition::getRefString | ( |  | ) | const

virtual

Get the reference type (for records, including codes like R_).

Implements casacore::Measure.

## getType() [1/2]

MPosition::Types casacore::MPosition::getType | ( | const String & | in | ) |

static

this one throws an exception for an unrecognized String

## getType() [2/2]

Bool casacore::MPosition::getType | ( | MPosition::Types & | tp,
|  | const String & | in )

static

Translate string to reference code.

## giveMe()

Bool casacore::MPosition::giveMe | ( | MPosition::Ref & | mr,
|  | const String & | in )

## operator=()

MPosition & casacore::MPosition::operator= | ( | const MPosition & |  | ) |

References MPosition().

## setOffset()

virtual Bool casacore::MPosition::setOffset | ( | const Measure & | in | ) |

virtual

Set the offset in the reference (False if non-matching Measure).

Implements casacore::Measure.

## setRefString()

virtual Bool casacore::MPosition::setRefString | ( | const String & | in | ) |

virtual

Set the reference type to the specified String.

False if illegal string, reference set to DEFAULT.

Implements casacore::Measure.

## showMe()

const String & casacore::MPosition::showMe | ( |  | ) |

static

## showType() [1/2]

const String & casacore::MPosition::showType | ( | MPosition::Types | tp | ) |

static

## showType() [2/2]

const String & casacore::MPosition::showType | ( | uInt | tp | ) |

static

## tellMe()

virtual const String & casacore::MPosition::tellMe | ( |  | ) | const

virtual

Tell me your type.

Implements casacore::Measure.

## Friends And Related Symbol Documentation

## MeasConvert< MPosition >

friend class MeasConvert< MPosition >

friend

Conversion of data.

Definition at line 1 of file MPosition.h.

References MPosition().

The documentation for this class was generated from the following file:

- measures/Measures/MPosition.h